Attribute VB_Name = "mod_api_GetDeviceCaps_PPI_s4p_cal"
Option Compare Database
Option Explicit

'*************** Code Start *****************************************************
' module name: mod_api_GetDeviceCaps_PPI_s4p
'  http://msaccessgurus.com/VBA/Code/API_GetDeviceCaps_ppi.htm
'-------------------------------------------------------------------------------
' Purpose  : use GetDeviceCaps API to get ppi (pixel/inch)
' Author   : crystal (strive4peace)
' License  : below code
' Code List: www.msaccessgurus.com/code.htm
'-------------------------------------------------------------------------------
'  used by CalendarMaker
' edit 230214 using Peter Cole's API Viewer
'  https://www.thememydatabase.co.uk/access32to64.html

    Private Declare PtrSafe Function GetDC Lib "user32" _
      (ByVal hwnd As LongPtr _
      ) As LongPtr
   Private Declare PtrSafe Function ReleaseDC Lib "user32" ( _
       ByVal hwnd As LongPtr, _
       ByVal hdc As LongPtr _
       ) As Long
   Private Declare PtrSafe Function GetDeviceCaps Lib "gdi32" ( _
       ByVal hdc As LongPtr _
       , ByVal nIndex As Long _
       ) As Long

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ api_GetPPI
Function api_GetPPI(Optional pbHorizontal As Boolean = True) As Long
's4p 191120, 230206
'get pixels per inch. My monitor is 96 ppi.

   'PARAMETER
   '  pbHorizontal=True to return horizontal ppi, else vertical ppi
   
   Const LOGPIXELSX = 88 'pixels/inch in x, logical monitor
   Const LOGPIXELSY = 90 'pixels/inch in y

   'dimension Handle
   Dim hdc As LongPtr
         
   'set handle
   hdc = GetDC(0)
   
   If pbHorizontal <> True Then
      'Vertical ppi
      api_GetPPI = GetDeviceCaps(hdc, LOGPIXELSY) 'LOGPIXELSY=90
   Else
      'Horizontal ppi
      api_GetPPI = GetDeviceCaps(hdc, LOGPIXELSX)   'LOGPIXELSX=88
   End If
      
   'release handle
   hdc = ReleaseDC(0, hdc)
    
End Function
' LICENSE
'   You may freely use and share this code
'     provided this license notice and comment lines are not changed;
'     code may be modified provided you clearly note your changes.
'   You may not sell this code alone, or as part of a collection,
'     without my handwritten permission.
'   All ownership rights reserved. Use at your own risk.
'   ~ crystal (strive4peace)  www.msaccessgurus.com
'*************** Code End *******************************************************
